/*
* j1939_diagnostic.h - contains defines for diagnostic
*
* Copyright (c) 2014-2019 emotas embedded communication GmbH
*
*-------------------------------------------------------------------
* $Id: j1939_diagnostic.h 29508 2019-10-14 14:49:54Z hil $
*-------------------------------------------------------------------
*
*
*
*/

/**
* \brief data types
*
* \file j1939_diagnostic.h - contains defines for diagnostic
*
*/

#ifndef J1939_DIAGNOSTIC_H
#define J1939_DIAGNOSTIC_H 1


/* datatypes */

#define J1939_PGN_DM1	65226u
#define J1939_PGN_DM2	65227u
#define J1939_PGN_DM3	65228u
#define J1939_PGN_DM4	65229u
#define J1939_PGN_DM5	65230u
#define J1939_PGN_DM6	65231u
#define J1939_PGN_DM7	58112u
#define J1939_PGN_DM8	65232u

#define J1939_PGN_DM10	65234u
#define J1939_PGN_DM11	65235u
#define J1939_PGN_DM12	65236u
#define J1939_PGN_DM13	57088u
#define J1939_PGN_DM14	55552u
#define J1939_PGN_DM15	55296u
#define J1939_PGN_DM16	55040u
#define J1939_PGN_DM17	54784u
#define J1939_PGN_DM18	54272u
#define J1939_PGN_DM19	54016u
#define J1939_PGN_DM20	49664u
#define J1939_PGN_DM21	49408u
#define J1939_PGN_DM22	49920u
#define J1939_PGN_DM23	64949u
#define J1939_PGN_DM24	64950u
#define J1939_PGN_DM25	64951u
#define J1939_PGN_DM26	64952u
#define J1939_PGN_DM27	64898u
#define J1939_PGN_DM28	64896u
#define J1939_PGN_DM29	40448u
#define J1939_PGN_DM30	41984u
#define J1939_PGN_DM31	41728u
#define J1939_PGN_DM32	41472u
#define J1939_PGN_DM33	41216u
#define J1939_PGN_DM34	40960u
#define J1939_PGN_DM35	40704u
#define J1939_PGN_DM36	64868u
#define J1939_PGN_DM37	64867u
#define J1939_PGN_DM38	64866u
#define J1939_PGN_DM39	64865u
#define J1939_PGN_DM40	64864u
#define J1939_PGN_DM41	64863u
#define J1939_PGN_DM42	64862u
#define J1939_PGN_DM43	64861u
#define J1939_PGN_DM44	64860u
#define J1939_PGN_DM45	64859u
#define J1939_PGN_DM46	64858u
#define J1939_PGN_DM47	64857u
#define J1939_PGN_DM48	64856u
#define J1939_PGN_DM49	64855u
#define J1939_PGN_DM50	64854u
#define J1939_PGN_DM51	64853u
#define J1939_PGN_DM52	64852u
#define J1939_PGN_DM53	64721u
#define J1939_PGN_DM54	64722u
#define J1939_PGN_DM55	64723u
#define J1939_PGN_DM56	64711u
#define J1939_PGN_DM57	64710u


RET_T j1939DiagnosticMap_DM1(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp,
		UNSIGNED8 redStopLamp, UNSIGNED8 malFuncIndLamp,
		UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp,
		UNSIGNED32 spn, UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM1(void);

RET_T j1939DiagnosticGet_DM1(
		UNSIGNED8 *protectLamp, UNSIGNED8 *amberWarnLamp,
		UNSIGNED8 *redStopLamp, UNSIGNED8 *malFuncIndLamp,
		UNSIGNED8 *flashProtLamp, UNSIGNED8 *flashAmWarnLamp,
		UNSIGNED8 *flashRedStopLamp, UNSIGNED8 *flashMalfuncIndLamp,
		UNSIGNED32 *spn, UNSIGNED8 *fmi, UNSIGNED8 *cm, UNSIGNED8 *ocCnt);


RET_T j1939DiagnosticMap_DM2(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp,
		UNSIGNED8 redStopLamp, UNSIGNED8 malFuncIndLamp,
		UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp,
		UNSIGNED32 spn, UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM2(UNSIGNED8 dstNode);

RET_T j1939DiagnosticGet_DM2(
		UNSIGNED8 *protectLamp, UNSIGNED8 *amberWarnLamp,
		UNSIGNED8 *redStopLamp, UNSIGNED8 *malFuncIndLamp,
		UNSIGNED8 *flashProtLamp, UNSIGNED8 *flashAmWarnLamp,
		UNSIGNED8 *flashRedStopLamp, UNSIGNED8 *flashMalfuncIndLamp,
		UNSIGNED32 *spn, UNSIGNED8 *fmi, UNSIGNED8 *cm, UNSIGNED8 *ocCnt);


RET_T j1939DiagnosticSend_DM3(UNSIGNED8 destNode);


RET_T j1939DiagnosticMap_DM4(
		UNSIGNED32 spn, UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt,
		UNSIGNED8 engTorqMode, UNSIGNED8 engInManuPress, UNSIGNED16 engSpeed,
		UNSIGNED8 engPercLdCSpeed, UNSIGNED8 engCoolTemp,
		UNSIGNED16 wheelVehSpeed,
		const UNSIGNED8 *manuSpecInfo, UNSIGNED8	manuSpecInfoSize);
RET_T j1939DiagnosticSend_DM4(UNSIGNED8 dstNode);


RET_T j1939DiagnosticSend_DM5(
		UNSIGNED8 dstNode, UNSIGNED8 acticeDtcCnt, UNSIGNED8 prevActDtcCnt,
		UNSIGNED8 obdCompliance, UNSIGNED8 contMonSystemState,
		UNSIGNED16 nonContMonSysSup, UNSIGNED16 nonContMonSysState);


RET_T j1939DiagnosticMap_DM6(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp,
		UNSIGNED8 redStopLamp, UNSIGNED8 malFuncIndLamp,
		UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp,
		UNSIGNED32 spn, UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM6(UNSIGNED8 dstNode);


RET_T j1939DiagnosticGetPara_DM7(
		UNSIGNED8 *pTestIdent, UNSIGNED32 *pSpn, UNSIGNED8 *pFmi);


RET_T j1939DiagnosticMap_DM8(
		UNSIGNED8 testIdent, UNSIGNED8 testType, UNSIGNED16 testValue,
		UNSIGNED16 testLimitMax, UNSIGNED16 testLimitMin);
RET_T j1939DiagnosticSend_DM8(UNSIGNED8 dstNode);


RET_T j1939DiagnosticSend_DM10(
		UNSIGNED8 dstNode, const UNSIGNED8	*testIdSupported);


RET_T j1939DiagnosticSend_DM11(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM12(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp,
		UNSIGNED8 redStopLamp, UNSIGNED8 malFuncIndLamp,
		UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp,
		UNSIGNED32 spn, UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM12(UNSIGNED8 dstNode);


RET_T j1939DiagnosticGetPara_DM13(
		UNSIGNED8 *currentDataLink, UNSIGNED8 *j1587Network,
		UNSIGNED8 *j1922Network, UNSIGNED8 *j1939Network_1,
		UNSIGNED8 *j1939Network_2, UNSIGNED8 *iso9141Network,
		UNSIGNED8 *j1850Network, UNSIGNED8 *manuNetwork,
		UNSIGNED8 *j1939Network_3, UNSIGNED8 *propNetwork_1,
		UNSIGNED8 *propNetwork_2, UNSIGNED8 *j1939Network_4,
		UNSIGNED8 *holdSignal, UNSIGNED8 *suspendSignal,
		UNSIGNED16 *suspendDuration);


RET_T j1939DiagnosticGetPara_DM14(
		UNSIGNED16 *pLenNoReq,	UNSIGNED8 *pType, UNSIGNED8 *pCommand,
		UNSIGNED32 *pMem, UNSIGNED8 *pPtrExtension, UNSIGNED16 *pKey);


RET_T j1939DiagnosticSend_DM15(
		UNSIGNED8 dstNode, UNSIGNED16 lenNoAllowed, UNSIGNED8 state,
		UNSIGNED32 edcPara,	UNSIGNED8 edcpExtension, UNSIGNED16 seed);


RET_T j1939DiagnosticGetPara_DM16(
		UNSIGNED16 *pDataLen, UNSIGNED8 *pBuf, UNSIGNED16 maxBufLen);
RET_T j1939DiagnosticSend_DM16(
		UNSIGNED8 dstNode, const UNSIGNED8 *pBuf, UNSIGNED16 size);


RET_T j1939DiagnosticGetPara_DM17(UNSIGNED8 *pBuf);


RET_T j1939DiagnosticGetPara_DM18(
		UNSIGNED16 *pDataLen, UNSIGNED8 *pBuf, UNSIGNED16 maxBufLen);


RET_T j1939DiagnosticMap_DM19(
		UNSIGNED32 calVertification, const UNSIGNED8 *calIdent);
RET_T j1939DiagnosticSend_DM19(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM20(
		UNSIGNED16 engIgCycleCnt,
		UNSIGNED16 obdMonConEnCnt, UNSIGNED32 spn,
		UNSIGNED16 applSysMonNum, UNSIGNED16 applSysMonDen);
RET_T j1939DiagnosticSend_DM20(UNSIGNED8 dstNode);


RET_T j1939DiagnosticSend_DM21(UNSIGNED8 dstNode,
		UNSIGNED16 distTravel, UNSIGNED16 distDtcCleared,
		UNSIGNED16 minRun, UNSIGNED16 timeDtcCleard);


RET_T j1939DiagnosticSend_DM22(UNSIGNED8 dstNode, UNSIGNED8	dtcControl,
		UNSIGNED8 ctrlByteSpec, UNSIGNED32 spn, UNSIGNED8 fmi);


RET_T j1939DiagnosticMap_DM23(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp,
		UNSIGNED8 redStopLamp, UNSIGNED8 malFuncIndLamp,
		UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp,
		UNSIGNED32 spn, UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM23(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM24(UNSIGNED32 spn,
		UNSIGNED8 spnLen, UNSIGNED8	testResults, UNSIGNED8 inDataStream,
		UNSIGNED8 inFreezeFrame);
RET_T j1939DiagnosticSend_DM24(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM25(UNSIGNED32	spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt,
		const UNSIGNED8 *spnData, UNSIGNED8 spnDataSize);
RET_T j1939DiagnosticSend_DM25(UNSIGNED8 dstNode);


RET_T j1939DiagnosticSend_DM26(UNSIGNED8 dstNode,
		UNSIGNED16 timeSinceEngineStart, UNSIGNED8 noOfWarmUps,
		UNSIGNED8 contMonStatus, UNSIGNED16 nonContMonStatus);


RET_T j1939DiagnosticMap_DM27(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp,
		UNSIGNED8 redStopLamp, UNSIGNED8 malFuncIndLamp,
		UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp,
		UNSIGNED32 spn, UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM27(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM28(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp,
		UNSIGNED8 redStopLamp, UNSIGNED8 malFuncIndLamp,
		UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp,
		UNSIGNED32 spn, UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM28(UNSIGNED8 dstNode);


RET_T j1939DiagnosticSend_DM29(UNSIGNED8 dstNode,
		UNSIGNED8 dtcCnt, UNSIGNED8 allDtcCnt, UNSIGNED8 erMilOnDtcCnt,
		UNSIGNED8 erPrevOnDtcCnt, UNSIGNED8	erPermDtcCnt);


RET_T j1939DiagnosticMap_DM30(UNSIGNED8 testIdent, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED16 slotIdent, UNSIGNED16 testValue,
		UNSIGNED16 testLimitMax, UNSIGNED16 testLimitMin);
RET_T j1939DiagnosticSend_DM30(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM31(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp,
		UNSIGNED8 redStopLamp, UNSIGNED8 malFuncIndLamp,
		UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp,
		UNSIGNED32 spn, UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM31(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM32(
		UNSIGNED32	spn, UNSIGNED8	fmi, UNSIGNED16	totalActiveTime,
		UNSIGNED16	totalPrevActiveTime, UNSIGNED8	timeUntilDerate);
RET_T j1939DiagnosticSend_DM32(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM33(
		UNSIGNED8 eiAecdNr, UNSIGNED32 eiAecdHoursT1, UNSIGNED32 eiAecdHoursT2);
RET_T j1939DiagnosticSend_DM33(UNSIGNED8 dstNode);


RET_T j1939DiagnosticSend_DM34(
		UNSIGNED8 dstNode, UNSIGNED8 noxNteCtrlState, UNSIGNED8 manuNoxNteState,
		UNSIGNED8 noxNteAreaState, UNSIGNED8 pmNteCtrlState, UNSIGNED8 manuPmNteState,
		UNSIGNED8 pmNteAreaState);


RET_T j1939DiagnosticMap_DM35(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp,
		UNSIGNED8 redStopLamp, UNSIGNED8 malFuncIndLamp,
		UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp,
		UNSIGNED32 spn, UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM35(UNSIGNED8 dstNode);


RET_T j1939DiagnosticSend_DM36(
		UNSIGNED8 dstNode, UNSIGNED8 compCnt, UNSIGNED8 contMalInd,
		UNSIGNED8 indStrategy, UNSIGNED8 actMode, UNSIGNED16 monCnt, UNSIGNED16 accTime);


RET_T j1939DiagnosticSend_DM37(
		UNSIGNED8 dstNode, UNSIGNED8 sysCnt, UNSIGNED8 malInd, UNSIGNED8 dispStrat,
		UNSIGNED8 actMode, UNSIGNED16 incMonCnt);


RET_T j1939DiagnosticSend_DM38(
		UNSIGNED8 dstNode, UNSIGNED8 *descr, UNSIGNED8 descrLen);


RET_T j1939DiagnosticSend_DM39(
		UNSIGNED8 dstNode, UNSIGNED32 cumTime, UNSIGNED16 greatCnt);


RET_T j1939DiagnosticMap_DM40(
		UNSIGNED32 spn, UNSIGNED8 fmi, UNSIGNED16 cnt);
RET_T j1939DiagnosticSend_DM40(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM41(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM41(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM42(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM42(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM43(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM43(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM44(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM44(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM45(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM45(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM46(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM46(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM47(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM47(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM48(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM48(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM49(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM49(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM50(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM50(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM51(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM51(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM52(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM52(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM53(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM53(UNSIGNED8 dstNode);


RET_T j1939DiagnosticMap_DM54(
		UNSIGNED8 protectLamp, UNSIGNED8 amberWarnLamp, UNSIGNED8 redStopLamp,
		UNSIGNED8 malFuncIndLamp, UNSIGNED8 flashProtLamp, UNSIGNED8 flashAmWarnLamp,
		UNSIGNED8 flashRedStopLamp, UNSIGNED8 flashMalfuncIndLamp, UNSIGNED32 spn,
		UNSIGNED8 fmi, UNSIGNED8 cm, UNSIGNED8 ocCnt);
RET_T j1939DiagnosticSend_DM54(UNSIGNED8 dstNode);


RET_T j1939DiagnosticSend_DM55(UNSIGNED8 dstNode);


RET_T j1939DiagnosticSend_DM56(
		UNSIGNED8 dstNode, char *modelYear, char *certName, UNSIGNED8 certLen);


RET_T j1939DiagnosticSend_DM57(UNSIGNED8 dstNode, UNSIGNED8 obdSeq);

#endif /* J1939_DIAGNOSTIC_H */

